#include <cassert>

#include "npstat/rng/assignResamplingWeights.hh"

namespace npstat {
    void assignResamplingWeights(AbsRandomGenerator& gen,
                                 const unsigned long nPoints,
                                 const unsigned long sampleSizeWanted,
                                 std::vector<double>* to)
    {
        assert(to);
        to->clear();
        to->resize(nPoints);

        if (nPoints)
        {
            const double dsz = nPoints;
            double* weights = &(*to)[0];
            for (unsigned long i=0; i<sampleSizeWanted; ++i)
            {
                unsigned long idx = nPoints;
                while (idx >= nPoints)
                    idx = static_cast<unsigned long>(dsz*gen());
                weights[idx] += 1.0;
            }
        }
    }
}
