#include <cassert>

#include "npstat/stat/bivariateChiSquare.hh"

double bivariateChiSquare(const double mux, const double muy,
                          const double sx, const double sy,
                          const double rho, const double x, const double y)
{
    assert(sx > 0.0);
    assert(sy > 0.0);
    const double denom = 1.0 - rho*rho;
    assert(denom > 0.0);
    const double dx = (x - mux)/sx;
    const double dy = (y - muy)/sy;
    return (dx*dx + dy*dy - 2.0*rho*dx*dy)/denom;
}
