#ifndef NPSTAT_SADDLEPOINTDISTRIBUTION1D_HH_
#define NPSTAT_SADDLEPOINTDISTRIBUTION1D_HH_

/*!
// \file saddlepointDistribution1D.hh
//
// \brief Function for building univariate distributions by tabulating and
//        normalizing the saddlepoint density approximations
//
// Author: I. Volobouev
//
// December 2019
*/

#include "geners/CPP11_auto_ptr.hh"

#include "npstat/stat/AbsCGF1D.hh"
#include "npstat/stat/Distributions1D.hh"

namespace npstat {
    CPP11_auto_ptr<Tabulated1D> saddlepointDistribution1D(
        const AbsCGF1D& cgf, unsigned saddlepointApproximationOrder,
        unsigned tableInterpolationDegree, unsigned nCoords,
        double xmin, double xmax);

#ifdef SWIG
    inline Tabulated1D* saddlepointDistribution1D_2(
        const AbsCGF1D& cgf, unsigned saddlepointApproximationOrder,
        unsigned tableInterpolationDegree, unsigned nCoords,
        double xmin, double xmax)
    {
        CPP11_auto_ptr<Tabulated1D> ptr = saddlepointDistribution1D(
            cgf, saddlepointApproximationOrder, tableInterpolationDegree,
            nCoords, xmin, xmax);
        return ptr.release();
    }
#endif
}

#endif // NPSTAT_SADDLEPOINTDISTRIBUTION1D_HH_
