#include <iostream>

#include "npstat/stat/solveForLOrPEWeights.hh"

namespace npstat {
    void LOrPEWeightsResult::print(std::ostream& os) const
    {
        os << "alpha = " << alpha_ << '\n'
           << "filterDegree = " << cvResult_.filterDegree() << '\n'
           << "bwFactor = " << cvResult_.bwFactor() << '\n'
           << "cvFunction = " << cvResult_.cvFunction() << '\n'
           << "onDegreeBoundary = " << cvResult_.isOnDegreeBoundary() << '\n'
           << "onBandwidthBoundary = " << cvResult_.isOnBandwidthBoundary() << '\n'
           << "nIterations = " << nIterations_ << '\n'
           << "converged = " << converged_ << '\n';
    }
}

std::ostream& operator<<(
    std::ostream& os, const npstat::LOrPEWeightsResult& res)
{
    res.print(os);
    return os;
}
